#[doc = "Register `PROT_VIRGINKEY7` reader"]
pub struct R(crate::R<PROT_VIRGINKEY7_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PROT_VIRGINKEY7_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PROT_VIRGINKEY7_SPEC>> for R {
    fn from(reader: crate::R<PROT_VIRGINKEY7_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PROT_VIRGINKEY7` writer"]
pub struct W(crate::W<PROT_VIRGINKEY7_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PROT_VIRGINKEY7_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PROT_VIRGINKEY7_SPEC>> for W {
    fn from(writer: crate::W<PROT_VIRGINKEY7_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `KEY8` reader - Key Byte"]
pub struct KEY8_R(crate::FieldReader<u8, u8>);
impl KEY8_R {
    pub(crate) fn new(bits: u8) -> Self {
        KEY8_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for KEY8_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `KEY8` writer - Key Byte"]
pub struct KEY8_W<'a> {
    w: &'a mut W,
}
impl<'a> KEY8_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Key Byte"]
    #[inline(always)]
    pub fn key8(&self) -> KEY8_R {
        KEY8_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Key Byte"]
    #[inline(always)]
    pub fn key8(&mut self) -> KEY8_W {
        KEY8_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Virgin Protection Mode Key\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [prot_virginkey7](index.html) module"]
pub struct PROT_VIRGINKEY7_SPEC;
impl crate::RegisterSpec for PROT_VIRGINKEY7_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [prot_virginkey7::R](R) reader structure"]
impl crate::Readable for PROT_VIRGINKEY7_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [prot_virginkey7::W](W) writer structure"]
impl crate::Writable for PROT_VIRGINKEY7_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PROT_VIRGINKEY7 to value 0"]
impl crate::Resettable for PROT_VIRGINKEY7_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
